Index: trunk/LMDZ.COMMON/libf/evolution/ComputeCO2Adsorption.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/ComputeCO2Adsorption.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/ComputeCO2Adsorption.F90	(revision 2794)
@@ -0,0 +1,97 @@
+   SUBROUTINE regolith_co2adsorption_old(ngrid,nslope,nsoil_PEM,ps,tsoil_PEM,TI_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,m_co2_completesoil,delta_mreg)
+      use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,n_1km
+      USE comcstfi_h, only: r, cpp, mugaz, g, rcp, pi, rad 
+      use comslope_mod, only : subslope_dist,def_slope_mean
+      IMPLICIT NONE
+! Input: 
+ INTEGER,INTENT(IN) :: ngrid, nslope, nsoil_PEM
+ REAL,INTENT(IN) :: ps(ngrid)                                      ! Average surface pressure [Pa]
+ REAL,INTENT(IN) :: tsoil_PEM(ngrid,nsoil_PEM,nslope)               ! Mean Soil Temperature [K]
+ REAL,INTENT(IN) :: TI_PEM(ngrid,nsoil_PEM,nslope)                  ! Mean Thermal Inertia [USI]
+ REAL,INTENT(IN) :: tend_h2oglaciers(ngrid,nslope),tend_co2glaciers(ngrid,nslope) !tendancies on the glaciers
+ REAL,INTENT(IN) :: waterice(ngrid,nslope)                          ! water ice at the surface [KG/m^2]
+ REAL,INTENT(IN) :: co2ice(ngrid,nslope)                            ! co2 ice at the surface [Kg/m^2] 
+
+! Outputs:
+ REAL,INTENT(INOUT) :: m_co2_completesoil(ngrid,nsoil_PEM,nslope)
+ REAL,INTENT(INOUT) :: delta_mreg(ngrid)
+
+
+  
+! Constants:
+
+ REAL ::  as = 1.9e4      ! Bulher & Piqueux 2020, assuming exchange only between 0 and 868m, last layer of the PEM
+ REAL ::  delta = 5.749e1 ! Zent & Quinn, 1995
+ REAL ::  beta =  -4.0711 ! Zent & Quinn, 1995
+ REAL ::  gama =  0.2788  ! Zent & Quinn, 1995
+ REAL ::  inertie_thresold = 2000. ! look for ice
+ REAL ::  rho_regolith = 2000. ! density of the reoglith, buhler and piqueux 2021
+! Input: Local 
+ INTEGER :: ig,islope,iloop,iref,k
+ REAL :: dm_co2_regolith_slope(ngrid,nsoil_PEM,nslope)   ! elementary mass adsorded per mesh per slope
+ INTEGER :: ispermanent_co2glaciers(ngrid,nslope)
+ INTEGER :: ispermanent_h2oglaciers(ngrid,nslope)
+ REAL :: deltam_reg_complete(ngrid,n_1km,nslope)
+ REAL :: deltam_reg_slope(ngrid,nslope)
+
+dm_co2_regolith_slope(:,:,:) = 0
+delta_mreg(:) = 0.
+!0. Initialization
+  do ig = 1,ngrid
+    do islope = 1,nslope
+     if((abs(tend_h2oglaciers(ig,islope)).gt.1e-5).and.(abs(waterice(ig,islope)).gt.0)) then
+        ispermanent_h2oglaciers(ig,islope) = 1
+     else
+        ispermanent_h2oglaciers(ig,islope) = 0
+     endif
+
+     if((abs(tend_co2glaciers(ig,islope)).gt.1e-5).and.(abs(co2ice(ig,islope)).gt.0)) then
+        ispermanent_co2glaciers(ig,islope) = 1
+     else
+        ispermanent_co2glaciers(ig,islope) = 0
+     endif
+    enddo
+   enddo
+! 1. we compute the mass of co2 adsorded in each layer of the meshes  
+
+ do ig = 1,ngrid
+  do islope = 1,nslope
+    do iloop = 1,n_1km
+     if((TI_PEM(ig,iloop,islope).lt.inertie_thresold).and.(ispermanent_h2oglaciers(ig,islope).eq.0).and.(ispermanent_co2glaciers(ig,islope).eq.0)) then
+     dm_co2_regolith_slope(ig,iloop,islope) = rho_regolith*as*delta*(ps(ig)**gama)*(tsoil_PEM(ig,iloop,islope))**beta 
+     else
+        if(abs(m_co2_completesoil(ig,iloop,islope)).lt.1-10) then !!! we are at first call
+          dm_co2_regolith_slope(ig,iloop,islope) = rho_regolith*as*delta*(ps(ig)**gama)*(tsoil_PEM(ig,iloop,islope))**beta 
+        else ! no change: permanent ice stick the atoms of CO2
+          dm_co2_regolith_slope(ig,iloop,islope) = m_co2_completesoil(ig,iloop,islope)
+        endif
+     endif
+  enddo
+ enddo
+enddo
+
+
+! 2. Check the exchange between the atmosphere and the regolith
+
+  do ig = 1,ngrid
+   delta_mreg(ig) = 0.
+   do islope = 1,nslope
+    deltam_reg_slope(ig,islope) = 0.
+    do iloop = 1,n_1km
+       if((TI_PEM(ig,iloop,islope).lt.inertie_thresold).and.(ispermanent_h2oglaciers(ig,islope).eq.0).and.(ispermanent_co2glaciers(ig,islope).eq.0)) then
+             deltam_reg_complete(ig,iloop,islope) = (dm_co2_regolith_slope(ig,iloop,islope) - m_co2_completesoil(ig,iloop,islope)) &
+                                                   *(layer_PEM(iloop+1) - layer_PEM(iloop)) 
+       else ! NO EXCHANGE AS ICE BLOCK THE DYNAMIC!
+             deltam_reg_complete(ig,iloop,islope) = 0.
+       endif
+       deltam_reg_slope(ig,islope) = deltam_reg_slope(ig,islope) + deltam_reg_complete(ig,iloop,islope)
+    enddo
+   delta_mreg(ig) = delta_mreg(ig) + deltam_reg_slope(ig,islope)*subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)
+   enddo
+  enddo
+   m_co2_completesoil(:,:,:) = dm_co2_regolith_slope(:,:,:)
+
+
+!=======================================================================
+      RETURN
+      END
Index: trunk/LMDZ.COMMON/libf/evolution/Example_ice_evol.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/Example_ice_evol.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/Example_ice_evol.F90	(revision 2794)
@@ -0,0 +1,27 @@
+         ! Update surface ice distribution to iterate to steady state if requested
+         if(ice_update)then
+
+            do ig=1,ngrid
+
+               delta_ice = (qsurf(ig,igcm_h2o_ice)-ice_initial(ig))
+               
+               ! add multiple years of evolution
+               qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice) + delta_ice*icetstep 
+
+               ! if ice has gone -ve, set to zero
+               if(qsurf_hist(ig,igcm_h2o_ice).lt.0.0)then
+                  qsurf_hist(ig,igcm_h2o_ice) = 0.0 
+               endif
+
+               ! if ice is seasonal, set to zero (NEW)
+               if(ice_min(ig).lt.0.01)then
+                  qsurf_hist(ig,igcm_h2o_ice) = 0.0 
+               endif
+
+            enddo
+
+            ! enforce ice conservation
+            ice_tot= SUM(qsurf_hist(:,igcm_h2o_ice)*cell_area(:) )/SUM(cell_area(:))
+            qsurf_hist(:,igcm_h2o_ice) = qsurf_hist(:,igcm_h2o_ice)*(icesrf/ice_tot)
+
+         endif
Index: trunk/LMDZ.COMMON/libf/evolution/adsorption_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/adsorption_mod.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/adsorption_mod.F90	(revision 2794)
@@ -0,0 +1,286 @@
+  module adsorption_mod  
+  implicit none
+  contains
+
+
+
+  subroutine regolith_h2oadsorption(ngrid,nslope,nsoil_PEM,timelen, ps,q_co2,q_h2o,tsoil_PEM,TI_PEM, theta_h2o_adsorbded,m_h2o_adsorbed)
+
+ use vertical_layers_mod, ONLY: ap,bp
+ use comsoil_h_PEM, only: n_1km
+
+ implicit none
+
+
+ INTEGER,INTENT(IN) :: ngrid, nslope, nsoil_PEM,timelen ! size dimension
+ REAL,INTENT(IN) :: ps(ngrid,timelen)                   ! surface pressure (Pa)          
+ REAL,INTENT(IN) :: q_co2(ngrid,timelen)                ! Mass mixing ratio of co2 in the first layer (kg/kg)
+ REAL,INTENT(IN) :: q_h2o(ngrid,timelen)                ! Mass mixing ratio of H2o in the first layer (kg/kg)
+ REAL,INTENT(IN) :: TI_PEM(ngrid,nsoil_PEM,nslope)      ! Soil Thermal inertia (J/K/^2/s^1/2)
+ REAL,INTENT(IN) :: tsoil_PEM(ngrid,nsoil_PEM,nslope)   ! Soil temperature (K)
+
+
+! output
+ REAL,INTENT(OUT) ::  m_h2o_adsorbed(ngrid,nsoil_PEM,nslope)     ! Density of h2o adsorbed (kg/m^3)
+ REAL,INTENT(OUT) :: theta_h2o_adsorbded(ngrid,nsoil_PEM,nslope) ! Fraction of the pores occupied by H2O molecules
+
+
+! constant
+ REAL :: Ko =  1.57e-8            ! Jackosky et al. 1997
+ REAL :: e = 2573.9               ! Jackosky et al. 1997
+ REAL :: mu = 0.48                ! Jackosky et al. 1997
+ REAL ::  inertie_thresold = 800. ! TI > 800 means cementation
+ real :: m_h2o = 18.01528E-3      ! Molecular weight of h2o (kg/mol)
+ real :: m_co2 = 44.01E-3         ! Molecular weight of co2 (kg/mol)
+ real :: m_noco2 = 33.37E-3       ! Molecular weight of non co2 (kg/mol)
+ REAL ::  rho_regolith = 2000.    ! density of the reoglith, Buhler & Piqueux 2021
+ real :: alpha_clapeyron = -6143.7! eq. (2) in Murphy & Koop 2005
+ real :: beta_clapeyron = 29.9074 ! eq. (2) in Murphy & Koop 2005
+ real :: mi = 2.84e-7             ! Mass of h2o per m^2 absorbed Jackosky et al. 1997
+ real :: as = 18.9e3              ! Specific area, Buhler & Piqueux 2021
+
+
+
+
+
+! local variable
+ real :: A,B                                                   ! Used to compute the mean mass above the surface
+ real :: K                                                     ! Used to compute theta
+ real :: p_sat                                                 ! saturated vapor pressure of ice
+ integer ig,iloop, islope,isoil,it                             ! for loops
+ real,allocatable :: mass_mean(:,:)                            ! mean mass above the surface
+ real,allocatable :: zplev_mean(:,:)                           ! pressure above the surface
+ real,allocatable :: pvapor(:,:)                               ! partial pressure above the surface
+ real, allocatable :: pvapor_avg(:)                            ! yearly average vapor pressure above the surface
+
+
+
+! 0. Some initializations
+
+
+   
+     allocate(mass_mean(ngrid,timelen))
+     allocate(zplev_mean(ngrid,timelen))
+     allocate(pvapor(ngrid,timelen))
+     allocate(pvapor_avg(ngrid))
+
+      m_h2o_adsorbed(:,:,:) = 0.
+      theta_h2o_adsorbded(:,:,:) = 0.
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+! 1. Compute rho surface yearly averaged
+
+!   1.1 Compute the partial pressure of vapor
+!a. the molecular mass into the column
+     do ig = 1,ngrid
+       mass_mean(ig,:) = 1/(A*q_co2(ig,:) +B)
+     enddo
+
+
+! b. pressure level
+     do it = 1,timelen
+       do ig = 1,ngrid
+         zplev_mean(ig,it) = ap(1) + bp(1)*ps(ig,it)
+       enddo
+     enddo
+
+! c. Vapor pressure
+     pvapor(:,:) = mass_mean(:,:)/m_h2o*q_h2o(:,:)*zplev_mean(:,:)
+     pvapor_avg(:) = sum(pvapor(:,:),2)/timelen
+
+     deallocate(pvapor)
+     deallocate(zplev_mean)
+     deallocate(mass_mean)
+
+
+
+
+
+! 2. we compute the mass of co2 adsorded in each layer of the meshes  
+
+ do ig = 1,ngrid
+  do islope = 1,nslope
+    do iloop = 1,n_1km
+     if(TI_PEM(ig,iloop,islope).lt.inertie_thresold)  then
+       K = Ko*exp(e/tsoil_PEM(ig,iloop,islope))
+       theta_h2o_adsorbded(ig,iloop,islope) = (K*pvapor_avg(ig)/(1+K*pvapor_avg(ig)))**mu
+       m_h2o_adsorbed(ig,iloop,islope) = as*theta_h2o_adsorbded(ig,iloop,islope)*mi*rho_regolith
+     else
+        p_sat =exp(alpha_clapeyron/tsoil_PEM(ig,iloop,islope) +beta_clapeyron) ! we assume fixed temperature in the ice ... not really:q good but ...
+        theta_h2o_adsorbded(ig,iloop,islope) = (K*p_sat/(1+K*p_sat))**mu
+        m_h2o_adsorbed(ig,iloop,islope) =as*theta_h2o_adsorbded(ig,iloop,islope)*mi*rho_regolith
+      endif
+ 
+   enddo
+  enddo
+ enddo
+
+ RETURN
+  end subroutine
+
+
+  SUBROUTINE regolith_co2adsorption(ngrid,nslope,nsoil_PEM,timelen,ps,tsoil_PEM,TI_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,q_co2,q_h2o,m_co2_completesoil,delta_mreg)
+      use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,n_1km
+      USE comcstfi_h, only: r, cpp, mugaz, g, rcp, pi, rad 
+      use comslope_mod, only : subslope_dist,def_slope_mean
+      use vertical_layers_mod, ONLY: ap,bp
+
+      IMPLICIT NONE
+! Input:  
+ INTEGER,INTENT(IN) :: ngrid, nslope, nsoil_PEM,timelen             ! size dimension
+ REAL,INTENT(IN) :: ps(ngrid,timelen)                               ! Average surface pressure [Pa]
+ REAL,INTENT(IN) :: tsoil_PEM(ngrid,nsoil_PEM,nslope)               ! Mean Soil Temperature [K]
+ REAL,INTENT(IN) :: TI_PEM(ngrid,nsoil_PEM,nslope)                  ! Mean Thermal Inertia [USI]
+ REAL,INTENT(IN) :: tend_h2oglaciers(ngrid,nslope),tend_co2glaciers(ngrid,nslope) !tendancies on the glaciers ()
+ REAL,INTENT(IN) :: q_co2(ngrid,timelen),q_h2o(ngrid,timelen)       ! Mass mixing ratio of co2 and h2o in the first layer (kg/kg)
+ REAL,INTENT(IN) :: waterice(ngrid,nslope)                          ! water ice at the surface [kg/m^2]
+ REAL,INTENT(IN) :: co2ice(ngrid,nslope)                            ! co2 ice at the surface [kg/m^2] 
+
+! Outputs:
+ REAL,INTENT(INOUT) :: m_co2_completesoil(ngrid,nsoil_PEM,nslope)   ! Density of co2 adsorbed (kg/m^3)
+ REAL,INTENT(INOUT) :: delta_mreg(ngrid)                            ! Difference density of co2 adsorbed (kg/m^3)
+
+
+  
+! Constants:
+
+ REAL :: alpha = 7.512e-6 ! Zent & Quinn 1995
+ REAL :: beta =  -1541.5  ! Zent & Quinn 1995
+ REAL ::  inertie_thresold = 800. ! TI > 800 means cementation
+ REAL ::  rho_regolith = 2000. ! density of the reoglith, buhler & piqueux 2021
+ real :: m_co2 = 44.01E-3      ! Molecular weight of co2 (kg/mol)
+ real :: m_noco2 = 33.37E-3    ! Molecular weight of h2o (kg/mol)
+ real :: m_theta = 4.27e-7     ! Mass of co2 per m^2 absorbed 
+ real :: as = 18.9e3              ! Specific area, Buhler & Piqueux 2021
+
+! Local          
+ real :: A,B                                             ! Used to compute the mean mass above the surface
+ INTEGER :: ig,islope,iloop,it                           ! for loops
+ REAL :: dm_co2_regolith_slope(ngrid,nsoil_PEM,nslope)   ! elementary mass adsorded per mesh per slope
+ INTEGER :: ispermanent_co2glaciers(ngrid,nslope)        ! Check if the glacier is permanent
+ INTEGER :: ispermanent_h2oglaciers(ngrid,nslope)        ! Check if the glacier is permanent
+ REAL :: deltam_reg_complete(ngrid,n_1km,nslope)         ! Difference in the mass per slope and soil layer (kg/m^3)
+ REAL :: deltam_reg_slope(ngrid,nslope)                  ! Difference in the mass per slope  (kg/m^3)
+ REAL :: m_h2o_adsorbed(ngrid,nsoil_PEM,nslope)          ! Density of CO2 adsorbed (kg/m^3)
+ REAL :: theta_h2o_adsorbed(ngrid,nsoil_PEM,nslope)     ! Fraction of the pores occupied by H2O molecules
+!timelen array are allocated because heavy ...
+ real,allocatable :: mass_mean(:,:)                            ! mean mass above the surface
+ real,allocatable :: zplev_mean(:,:)                           ! pressure above the surface
+ real,allocatable :: pco2(:,:)                                  ! partial pressure above the surface
+ real, allocatable :: pco2_avg(:)                              ! yearly averaged
+
+
+
+! 0. Some initializations
+
+
+
+     allocate(mass_mean(ngrid,timelen))
+     allocate(zplev_mean(ngrid,timelen))
+     allocate(pco2(ngrid,timelen))
+     allocate(pco2_avg(ngrid))
+  
+      m_h2o_adsorbed(:,:,:) = 0.
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+
+     dm_co2_regolith_slope(:,:,:) = 0
+     delta_mreg(:) = 0.
+
+
+
+!0.1 Look at perenial ice
+  do ig = 1,ngrid
+    do islope = 1,nslope
+     if((abs(tend_h2oglaciers(ig,islope)).gt.1e-5).and.(abs(waterice(ig,islope)).gt.0)) then
+        ispermanent_h2oglaciers(ig,islope) = 1
+     else
+        ispermanent_h2oglaciers(ig,islope) = 0
+     endif
+
+     if((abs(tend_co2glaciers(ig,islope)).gt.1e-5).and.(abs(co2ice(ig,islope)).gt.0)) then
+        ispermanent_co2glaciers(ig,islope) = 1
+     else
+        ispermanent_co2glaciers(ig,islope) = 0
+     endif
+    enddo
+   enddo
+
+
+!   0.2  Compute the partial pressure of CO2
+!a. the molecular mass into the column
+     do ig = 1,ngrid
+       mass_mean(ig,:) = 1/(A*q_co2(ig,:) +B)
+     enddo
+
+
+! b. pressure level
+     do it = 1,timelen
+       do ig = 1,ngrid
+         zplev_mean(ig,it) = ap(1) + bp(1)*ps(ig,it)
+       enddo
+     enddo
+
+! c. Vapor pressure
+     pco2(:,:) = mass_mean(:,:)/m_co2*q_co2(:,:)*zplev_mean(:,:)
+     pco2_avg(:) = sum(pco2(:,:),2)/timelen
+
+ 
+     deallocate(zplev_mean)
+     deallocate(mass_mean)
+     deallocate(pco2)
+
+
+! 1. Compute the fraction of the pores occupied by H2O
+ call regolith_h2oadsorption(ngrid,nslope,nsoil_PEM,timelen, ps,q_co2,q_h2o,tsoil_PEM,TI_PEM,theta_h2o_adsorbed, m_h2o_adsorbed)
+
+
+
+! 2.  we compute the mass of co2 adsorded in each layer of the meshes  
+
+ do ig = 1,ngrid
+  do islope = 1,nslope
+    do iloop = 1,n_1km
+     if((TI_PEM(ig,iloop,islope).lt.inertie_thresold).and.(ispermanent_h2oglaciers(ig,islope).eq.0).and.(ispermanent_co2glaciers(ig,islope).eq.0)) then
+     dm_co2_regolith_slope(ig,iloop,islope) = as*rho_regolith*m_theta*(1-theta_h2o_adsorbed(ig,iloop,islope))*alpha*pco2_avg(ig)/ &
+                                             (alpha*pco2_avg(ig)+sqrt(tsoil_PEM(ig,iloop,islope))*exp(beta/tsoil_PEM(ig,iloop,islope)))
+     else
+        if(abs(m_co2_completesoil(ig,iloop,islope)).lt.1-10) then !!! we are at first call
+          dm_co2_regolith_slope(ig,iloop,islope) = as*rho_regolith*m_theta*(1-theta_h2o_adsorbed(ig,iloop,islope))*alpha*pco2_avg(ig) &
+                                                 /(alpha*pco2_avg(ig)+sqrt(tsoil_PEM(ig,iloop,islope))*exp(beta/tsoil_PEM(ig,iloop,islope))) 
+        else ! no change: permanent ice stick the atoms of CO2
+          dm_co2_regolith_slope(ig,iloop,islope) = m_co2_completesoil(ig,iloop,islope)
+        endif
+     endif
+  enddo
+ enddo
+enddo
+
+
+! 2. Check the exchange between the atmosphere and the regolith
+
+  do ig = 1,ngrid
+   delta_mreg(ig) = 0.
+   do islope = 1,nslope
+    deltam_reg_slope(ig,islope) = 0.
+    do iloop = 1,n_1km
+       if((TI_PEM(ig,iloop,islope).lt.inertie_thresold).and.(ispermanent_h2oglaciers(ig,islope).eq.0).and.(ispermanent_co2glaciers(ig,islope).eq.0)) then
+             deltam_reg_complete(ig,iloop,islope) = (dm_co2_regolith_slope(ig,iloop,islope) - m_co2_completesoil(ig,iloop,islope)) &
+                                                   *(layer_PEM(iloop+1) - layer_PEM(iloop)) 
+       else ! NO EXCHANGE AS ICE BLOCK THE DYNAMIC!
+             deltam_reg_complete(ig,iloop,islope) = 0.
+       endif
+       deltam_reg_slope(ig,islope) = deltam_reg_slope(ig,islope) + deltam_reg_complete(ig,iloop,islope)
+    enddo
+   delta_mreg(ig) = delta_mreg(ig) + deltam_reg_slope(ig,islope)*subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)
+   enddo
+  enddo
+   m_co2_completesoil(:,:,:) = dm_co2_regolith_slope(:,:,:)
+
+
+!=======================================================================
+      RETURN
+      END
+
+
+   end module
Index: trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90	(revision 2792)
+++ trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90	(revision 2794)
@@ -46,11 +46,17 @@
   ENDDO
 
+     print *, "jjm_input+1", jjm_input+1
+     print *, "iim_input+1", iim_input+1
+     print *, "nslope+1", nslope+1
+
 !  If the difference is too small; there is no evolution
   DO j=1,jjm_input+1
     DO i = 1, iim_input
        DO islope = 1, nslope
+!         print *, "tendencies_h2o_ice(i,j,islope)LAAA", tendencies_h2o_ice(i,j,islope)
          if(abs(tendencies_h2o_ice(i,j,islope)).LT.1.0E-10) then
             tendencies_h2o_ice(i,j,islope)=0.
          endif
+!         print *, "tendencies_h2o_ice(i,j,islope)HERE", tendencies_h2o_ice(i,j,islope)
        enddo
     ENDDO
@@ -71,4 +77,6 @@
   tendencies_h2o_ice_phys(ig0,:) = tendencies_h2o_ice(1,jjm_input+1,:)
 
+!  print *, "tendencies_h2o_ice_physze", tendencies_h2o_ice_phys(:,:)
+
 
 END SUBROUTINE compute_tendencies_slope
Index: trunk/LMDZ.COMMON/libf/evolution/computeice_table.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/computeice_table.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/computeice_table.F90	(revision 2794)
@@ -0,0 +1,182 @@
+   SUBROUTINE computeice_table(timelen,ngrid,nslope,nsoil_GCM,nsoil_PEM,tsoil,tsurf,q_co2,q_h2o,ps,ice_table)
+    USE comsoil_h, only:  inertiedat, volcapa
+    USE vertical_layers_mod, ONLY: ap,bp
+    USE comsoil_h_PEM, only: layer_PEM 
+    implicit none 
+
+
+    integer,intent(in) :: timelen,ngrid,nslope,nsoil_PEM,nsoil_GCM
+    real,intent(in) :: tsoil(ngrid,nsoil_PEM,nslope,timelen)    ! soil temperature, timeseries [K]
+    real,intent(in) :: tsurf(ngrid,nslope,timelen)              ! surface temperature [K]
+    real,intent(in) :: q_co2(ngrid,timelen)                     ! MMR tracer co2 [kg/kg]
+    real,intent(in) :: q_h2o(ngrid,timelen)                     ! MMR tracer h2o [kg/kg]
+    real,intent(in) :: ps(ngrid,timelen)                        ! surface pressure [Pa]
+    real,intent(out) :: ice_table(ngrid,nslope)                 ! ice table [m]
+
+
+    real :: m_h2o = 18.01528E-3
+    real :: m_co2 = 44.01E-3  
+    real :: m_noco2 = 33.37E-3  
+    real :: A,B,z1,z2
+    real :: alpha = -6143.7 
+    real :: beta = 29.9074
+
+
+    integer ig, islope,isoil,it
+    real,allocatable :: mass_mean(:,:)                            ! mean mass above the surface
+    real,allocatable :: zplev_mean(:,:)                           ! pressure above the surface
+    real,allocatable :: pvapor(:,:)                               ! partial pressure above the surface
+
+    real,allocatable :: rhovapor(:,:,:)
+    real,allocatable :: rhovapor_avg(:,:)                          ! mean vapor_density at the surface yearly averaged
+
+    real :: psv_surf
+    real,allocatable :: rho_soil(:,:,:,:)            ! water vapor in the soil
+    real,allocatable :: rho_soil_avg(:,:,:)                ! water vapor in the soil yearly averaged
+
+    real,allocatable :: diff_rho(:,:,:)                    ! difference of vapor content
+
+
+
+     allocate(rhovapor(ngrid,nslope,timelen))
+     allocate(rhovapor_avg(ngrid,nslope))
+     allocate(pvapor(ngrid,timelen))
+
+     allocate(mass_mean(ngrid,timelen))
+     allocate(zplev_mean(ngrid,timelen))
+
+
+
+
+! 0. Some initializations
+
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+! 1. Compute rho surface yearly averaged
+
+!   1.1 Compute the partial pressure of vapor
+!a. the molecular mass into the column
+     do ig = 1,ngrid
+       mass_mean(ig,:) = 1/(A*q_co2(ig,:) +B)
+     enddo
+
+
+! b. pressure level
+     do it = 1,timelen
+       do ig = 1,ngrid
+         zplev_mean(ig,it) = ap(1) + bp(1)*ps(ig,it)
+       enddo
+     enddo
+
+! c. Vapor pressure
+     pvapor(:,:) = mass_mean(:,:)/m_h2o*q_h2o(:,:)*zplev_mean(:,:)
+    
+     deallocate(mass_mean)
+     deallocate(zplev_mean)
+  
+!    1.2   Check if there is frost at the surface and then compute the density
+!    at the surface
+     do ig = 1,ngrid
+       do islope = 1,nslope
+         do it = 1,timelen
+           psv_surf = exp(alpha/tsurf(ig,islope,it) +beta)
+          if ((isnan(psv_surf)).or.(isnan(pvapor(ig,it)))) then
+          write(*,*) 'pb vapor',ig,islope,it
+         stop
+         endif       
+         rhovapor(ig,islope,it) = min(psv_surf,pvapor(ig,it))/tsurf(ig,islope,it)
+         enddo
+       enddo
+     enddo
+     deallocate(pvapor)
+
+
+
+
+!    1.3 Density at the surface yearly averaged
+     rhovapor_avg(:,:) = SUM(rhovapor(:,:,:),3)/timelen
+
+
+     deallocate(rhovapor)
+
+
+
+
+! 2. Compute rho soil vapor
+   
+     allocate(rho_soil_avg(ngrid,nslope,nsoil_PEM))
+     allocate(rho_soil(ngrid,nslope,nsoil_PEM,timelen))
+
+     do ig = 1,ngrid
+       do islope = 1,nslope
+         do isoil = 1,nsoil_PEM
+            do it = 1,timelen 
+              rho_soil(ig,islope,isoil,it) = exp(alpha/tsoil(ig,isoil,islope,it) +beta)/tsoil(ig,isoil,islope,it)        
+             enddo
+           enddo
+       enddo
+     enddo
+
+
+
+    rho_soil_avg(:,:,:) = SUM( rho_soil(:,:,:,:),4)/timelen
+    deallocate(rho_soil)
+
+
+
+! 3. Computing ice table
+   
+    ice_table (:,:) = -1e4
+
+         allocate(diff_rho(ngrid,nslope,nsoil_PEM))
+
+         do isoil = 1,nsoil_PEM
+
+
+             diff_rho(:,:,isoil) = rhovapor_avg(:,:) - rho_soil_avg(:,:,isoil)
+!             write(*,*) 'diff =',ig,islope,isoil,diff_rho(ig,islope,isoil),rhovapor_avg(ig,islope) ,rho_soil_avg(ig,islope,isoil)
+         enddo
+    
+
+  deallocate(rhovapor_avg)
+      deallocate(rho_soil_avg)
+
+
+
+
+
+
+
+     do ig = 1,ngrid
+       do islope = 1,nslope
+         if(diff_rho(ig,islope,1) > 0) then
+           ice_table(ig,islope) = 0.
+         else
+           do isoil = 1,nsoil_PEM -1
+             if((diff_rho(ig,islope,isoil).lt.0).and.(diff_rho(ig,islope,isoil+1).gt.0.)) then
+               z1 = (diff_rho(ig,islope,isoil) - diff_rho(ig,islope,isoil+1))/(layer_PEM(isoil) - layer_PEM(isoil+1))
+               z2 = -layer_PEM(isoil+1)*z1 +  diff_rho(ig,islope,isoil+1)
+               ice_table(ig,islope) = -z2/z1
+               exit
+             endif
+           enddo
+          endif
+        enddo
+      enddo
+
+    
+    deallocate(diff_rho)
+
+
+
+
+
+
+!=======================================================================
+      RETURN
+
+
+
+
+
+      END
Index: trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90	(revision 2794)
@@ -0,0 +1,66 @@
+module comsoil_h_PEM
+
+implicit none
+! nsoilmx : number of subterranean layers
+!EM: old soil routine:      integer, parameter :: nsoilmx = 10
+  integer, parameter :: nsoilmx_PEM = 27 
+  integer, parameter :: n_1km = 23
+
+  real,save,allocatable,dimension(:) :: layer_PEM      ! soil layer depths
+  real,save,allocatable,dimension(:) :: mlayer_PEM     ! soil mid-layer depths
+  real,save,allocatable,dimension(:,:,:) :: TI_PEM ! soil thermal inertia
+    real,save,allocatable,dimension(:,:) :: inertiedat_PEM ! soil thermal inertia
+  ! variables (FC: built in firstcall in soil.F)
+  REAL,SAVE,ALLOCATABLE :: tsoil_PEM(:,:,:)       ! sub-surface temperatures (K)
+  real,save,allocatable :: mthermdiff_PEM(:,:)  ! (FC) mid-layer thermal diffusivity
+  real,save,allocatable :: thermdiff_PEM(:,:)   ! (FC) inter-layer thermal diffusivity
+  real,save,allocatable :: coefq_PEM(:)         ! (FC) q_{k+1/2} coefficients
+  real,save,allocatable :: coefd_PEM(:,:)       ! (FC) d_k coefficients
+  real,save,allocatable :: alph_PEM(:,:,:)        ! (FC) alpha_k coefficients
+  real,save,allocatable :: beta_PEM(:,:,:)        ! beta_k coefficients
+  real,save :: mu_PEM
+  real,parameter :: fluxgeo = 30e-3 !W/m^2
+  real, save, allocatable :: co2_adsorbded_phys(:,:,:)  ! co2 that is in the regolith (kg/m^2)
+
+contains
+
+  subroutine ini_comsoil_h_PEM(ngrid,nslope)
+  
+  implicit none
+  integer,intent(in) :: ngrid ! number of atmospheric columns
+  integer,intent(in) :: nslope ! number of slope within a mesh 
+
+    allocate(layer_PEM(nsoilmx_PEM)) !soil layer depths
+    allocate(mlayer_PEM(0:nsoilmx_PEM-1)) ! soil mid-layer depths
+    allocate(TI_PEM(ngrid,nsoilmx_PEM,nslope)) ! soil thermal inertia
+    allocate(tsoil_PEM(ngrid,nsoilmx_PEM,nslope)) ! soil temperatures
+    allocate(mthermdiff_PEM(ngrid,0:nsoilmx_PEM-1))
+    allocate(thermdiff_PEM(ngrid,nsoilmx_PEM-1))
+    allocate(coefq_PEM(0:nsoilmx_PEM-1))
+    allocate(coefd_PEM(ngrid,nsoilmx_PEM-1))
+    allocate(alph_PEM(ngrid,nsoilmx_PEM-1,nslope))
+    allocate(beta_PEM(ngrid,nsoilmx_PEM-1,nslope))
+    allocate(inertiedat_PEM(ngrid,nsoilmx_PEM)) ! soil thermal inertia
+    allocate(co2_adsorbded_phys(ngrid,nsoilmx_PEM,nslope))
+  end subroutine ini_comsoil_h_PEM
+
+
+  subroutine end_comsoil_h_PEM
+
+  implicit none
+
+    if (allocated(layer_PEM)) deallocate(layer_PEM)
+    if (allocated(mlayer_PEM)) deallocate(mlayer_PEM)
+    if (allocated(TI_PEM)) deallocate(TI_PEM)
+    if (allocated(tsoil_PEM)) deallocate(tsoil_PEM)
+    if (allocated(mthermdiff_PEM)) deallocate(mthermdiff_PEM)
+    if (allocated(thermdiff_PEM)) deallocate(thermdiff_PEM)
+    if (allocated(coefq_PEM)) deallocate(coefq_PEM) 
+    if (allocated(coefd_PEM)) deallocate(coefd_PEM)
+    if (allocated(alph_PEM)) deallocate(alph_PEM)
+    if (allocated(beta_PEM)) deallocate(beta_PEM)
+    if (allocated(inertiedat_PEM)) deallocate(inertiedat_PEM)
+    if (allocated(co2_adsorbded_phys)) deallocate(co2_adsorbded_phys)
+  end subroutine end_comsoil_h_PEM
+
+end module comsoil_h_PEM
Index: trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90	(revision 2794)
@@ -0,0 +1,72 @@
+!
+! $Id $
+!
+SUBROUTINE criterion_co2_ice_stop(cell_area,initial_co2_ice,co2ice,STOPPING,ngrid,latitude,n_band_lat)
+
+  USE temps_mod_evol, ONLY: alpha_criterion
+
+      IMPLICIT NONE
+
+!=======================================================================
+!
+!  Routine that checks if the criterion to stop the PEM is reached
+!
+!=======================================================================
+
+!   arguments:
+!   ----------
+
+!   INPUT
+  INTEGER, intent(in) :: ngrid                  ! # of grid physical grid points 
+  REAL,    intent(in) :: cell_area(ngrid)       ! physical point field : Area of the cells
+  REAL,    intent(in) ::  co2ice(ngrid)          ! physical point field : Actual density of water ice
+  REAL,    intent(in) ::  latitude(ngrid)          ! physical point field : Latitude
+  REAL,    intent(in) ::  initial_co2_ice(n_band_lat)  ! Initial/Actual surface of water ice
+
+
+
+!   OUTPUT
+  LOGICAL, intent(out) :: STOPPING              ! Logical : is the criterion reached?
+
+!   local:
+!   -----
+  INTEGER :: i,j,n_band_lat                    ! Loop
+  REAL :: present_co2(n_band_lat)  ! Initial/Actual surface of water ice
+  REAL :: pi
+
+!=======================================================================
+
+      pi=4.D0*DATAN(1.D0)
+
+!   initialisation to false
+    STOPPING=.FALSE.
+
+     do j=1,n_band_lat
+        present_co2(j)=0.
+     enddo
+
+  do i=1,ngrid
+            j=floor((latitude(i)+(pi/2))/(pi)*n_band_lat)+1
+      if(j.GT.n_band_lat) then
+          j=n_band_lat
+      endif
+      present_co2(j)=present_co2(j)+co2ice(i)*cell_area(i)
+  enddo
+  
+!   check of the criterion
+  do j=1,n_band_lat
+    if(present_co2(j).LT.initial_co2_ice(j)*(1-alpha_criterion) .OR. &
+       present_co2(j).GT.initial_co2_ice(j)*(1+alpha_criterion)) then
+         STOPPING=.TRUE. 
+         print *, "j", j
+         print *, "present_co2(j)", present_co2(j)
+         print *, "initial_co2_ice(j)", initial_co2_ice(j)
+    endif
+  enddo
+
+END SUBROUTINE criterion_co2_ice_stop
+
+
+
+
+
